<!DOCTYPE html>

<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Tugas Component</title>

    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
</head>

<body>

    <div id="app">

        <div v-if="selectedUser == ''" class="formInput">
            <input type="text" v-model="formUser">
            <button @click="addUser">
                Add</button>
        </div>
        <div v-if="selectedUser != ''" class="formEdit">
            <input type="text" v-model="selectedUser">
            <button  @click="updateUser">
                Update</button>
        </div>



        <div class="usersList">
            <ul>
                <users-component v-for="(user , index) in reverseUsers"  
                :user="user" 
                :key="index"
                @selected="selectedUser = $event">
                    
                </users-component>
            </ul>
        </div>


    </div>

 
    <script>

        var usersComponent = {
            template : `
            <li>
                {{ user.name }} ||
                <button @click="$emit('selected', user.name)">Edit</button>
                <button @click="deleteUser(index)">Delete</button>
            </li>`,
            data(){
                return {
                    username : '' 
                }
            },
            props : ['user'], deleteUser : Function,

            methods : {
                deleteUser: function (id) {
                    console.log(id);
                    let confirmation = confirm("Anda yakin ?")

                    if (confirmation) {
                        this.reverseUsers = this.reverseUsers.filter(function (item, index) {
                            return index != id
                        })
                    }
                }
            },
        }

        let vm = new Vue({
            el: '#app',
            components : {
                'users-component' : usersComponent
            },
            data: {
                users: [
                    { name: 'Muhammad Iqbal Mubarok' },
                    { name: 'Ruby Purwanti' },
                    { name: 'Faqih Muhammad' },
                ],
                formUser: '',
                editButton: false,
                idSelected: null,
                selectedUser : '',

            },

            computed: {
                reverseUsers: {
                    get: function () {
                        return this.users.slice().reverse()
                    },

                    set: function (value) {
                        this.users = value.slice().reverse()
                    }
                }
            },

            methods: {
                addUser: function () {
                    this.users.push({ name: this.formUser })
                    this.formUser = ''
                },

                editUser: function (id) {
                    this.formUser = this.reverseUsers[id].name
                    this.editButton = true,
                    this.idSelected = id
                },

                updateUser: function () {
                    this.reverseUsers[this.idSelected].name = this.selectedUser
                    this.selectedUser = ''
                    this.editButton = false
                },

                deleteUser: function (id) {
                    let confirmation = confirm("Anda yakin ?")
 
                    if (confirmation) {
                        this.reverseUsers = this.reverseUsers.filter(function (item, index) {
                            return index != id
                        })
                    }
                }
            }
        })

    </script>

</body>
</html>